<template>
  <div>
    <div class="form-group" v-show="this.templateNames.length > 0">
      <label>Save as:</label>
      <select
        ref="templateName"
        style="margin-right: 30px"
        class="form-control"
      >
        <option v-for="item in templateNames" :key="item">{{ item }}</option>
      </select>
    </div>
    <div class="form-group">
      <label v-if="this.templateNames.length == 0">Save as :</label>
      <label v-else>Save as (other):</label>
      <input type="text" ref="templateNameOther" class="form-control" />
    </div>
    <div class="popup_footer">
      <button
        type="button"
        class="btn btn-primary"
        @click="save"
        style="margin: 10px"
      >
        Save
      </button>

      <button @click="$emit('on-close')" class="btn btn-default" role="button">
        Close
      </button>
    </div>
  </div>
</template>

<script>
import { mapGetters } from "vuex";
import { ModalBus } from "../eventBus";

export default {
  data() {
    return { templateNames: [] };
  },
  created: function() {
    this.templateNames = Object.keys(
      JSON.parse(localStorage.getItem("templates") || "{}")
    );
  },
  props: {},
  computed: {
    ...mapGetters([
      "GETTER_DATA_TOP_PICK",
      "GETTER_DATA_BANNER",
      "GETTER_DATA_SEARCH",
      "GETTER_DATA_PRODUCT_OF_ROW",
      "GETTER_DATA_BLOGGER_NAME_ENABLE",
      "GETTER_DATA_BLOGGER_CTA_ENABLE"
    ])
  },
  methods: {
    save() {
      let templates = JSON.parse(localStorage.getItem("templates") || "{}");
      let template = {
        DATA_TOP_PICK: this.GETTER_DATA_TOP_PICK,
        DATA_BANNER: this.GETTER_DATA_BANNER,
        DATA_SEARCH: this.GETTER_DATA_SEARCH,
        DATA_BLOGGER_NAME_OPTIONS: this.GETTER_DATA_BLOGGER_NAME_ENABLE,
        DATA_BLOGGER_CTA_OPTIONS: this.GETTER_DATA_BLOGGER_CTA_ENABLE,
        DATA_PRODUCT_OF_ROW: this.GETTER_DATA_PRODUCT_OF_ROW
      };
      let templateName =
        this.$refs.templateNameOther.value ||
        this.$refs.templateName.value ||
        "default";

      templates[templateName] = template;
      localStorage.setItem("templates", JSON.stringify(templates));
      ModalBus.$emit("showNotify", {
        type: "success",
        text: "Save success."
      });
      this.$emit("on-close");
    }
  }
};
</script>

<style scoped></style>
